program copcfg;

{$I whichos.inc}

uses dos,crt,goodunit,glob,litebox,boxes;

{$ifdef FORNIX}
const dirsep = '/';
{$else}
const dirsep = '\';
{$endif}

const CONFIGFILE = 'LORDCOPS.CFG';
      {$ifdef FORNIX}
      STARTBAT = 'start.sh';
      LORDCOPSEXE = 'lordcops';
      {$else}
      STARTBAT = 'START.BAT';
      LORDCOPSEXE = 'LORDCOPS.EXE';
      {$endif}

type TCopCfg = record
        { the nums in comments match up to the line in the
          cinfig file }
        { 1}dopolice  : word;
        { 2}lordpath  : string;
        { 3}policeinn : word;
        { 4}maxhp     : longint;
        { 5}maxcash   : longint;
        { 6}maxxp     : longint;
        { 7}maxdef    : longint;
        { 8}maxstr    : longint;
        { 9}levels    : byte;
        {10}fine      : longint;
        {11}raidshops : longint;
        {12}raidreward: longint;
        {13}violet    : longint;
        {14}vioout    : longint;
        {15}version   : word;
     end;

var copsdir:string;
    textfile,
    textfile2:text;
    cfg : ^TCopCfg;
    ioerror:integer;
    varm5:m5;

function uppercase(s:string):string;
var b:byte;
begin
  for b := 1 to length(s) do s[b] := upcase(s[b]);
  uppercase := s;
end;


function file_exists(s:string):boolean;
var DirInfo:SearchRec;
begin
  findfirst(s, Archive, DirInfo);
  if DosError = 0 then
    file_exists := true
  else
    file_exists := false;
end;

function StrToInt(s:string):longint;
var i:longint;
    code:integer;
begin
  val(s,i,code);
  if code <> 0 then
    StrToInt := 0
  else
    StrToInt := i;
end;

function IntToStr(l:longint):string;
var s:string;
begin
  str(l,s);
  IntToStr := s;
end;

procedure install;
var s:string;
begin

  assign(textfile,cfg^.lordpath + STARTBAT);
  {$I-}reset(textfile);{$I+}

  ioerror := ioresult;

  if ioerror<>0 then
  begin
    varm5[1] := 'Error opening '+cfg^.lordpath + STARTBAT;
    varm5[2] := '(error code '+IntToStr(ioerror)+')';
    varm5[3] := 'Cannot install!';
    varm5[4] := '';
    varm5[5] := '';
    multimsgbox(varm5,true);
  end
  else
  begin
    if yesnobox('Install to '+cfg^.lordpath + STARTBAT + '?','Yes','No','Y','N',true) then
    begin
      assign(textfile2,cfg^.lordpath + 'START.~~~');
      rewrite(textfile2);
      writeln(textfile2,copsdir + LORDCOPSEXE);
      while not eof(textfile) do
      begin
        readln(textfile,s);
        writeln(textfile2,s);
      end;

      close(textfile);
      close(textfile2);

      erase(textfile);
      rename(textfile2,cfg^.lordpath + STARTBAT);

      msgbox('Installed!');

    end;
  end;

end;

procedure uninstall;
var s:string;
    found : boolean;
begin
  assign(textfile,cfg^.lordpath + STARTBAT);
  {$I-}reset(textfile);{$I+}

  ioerror := ioresult;

  if ioerror<>0 then
  begin
    varm5[1] := 'Error opening '+cfg^.lordpath + STARTBAT;
    varm5[2] := '(error code '+IntToStr(ioerror)+')';
    varm5[3] := 'Cannot uninstall!';
    varm5[4] := '';
    varm5[5] := '';
    multimsgbox(varm5,true);
  end
  else
  begin
    found := false;

    while (found=false) and (not eof(textfile)) do
    begin
      readln(textfile,s);
      if pos(uppercase(LORDCOPSEXE),uppercase(s)) <> 0 then found := true
    end;

    if found=false then
    begin
      close(textfile);
      msgbox('LordCops is not installed!');
    end
    else
    begin
      reset(textfile);
      assign(textfile2,cfg^.lordpath + 'START.~~~');
      rewrite(textfile2);

      while not eof(textfile) do
      begin
        readln(textfile,s);
        if pos(uppercase(LORDCOPSEXE),uppercase(s)) = 0 then
          writeln(textfile2,s);
      end;

      close(textfile);
      close(textfile2);

      erase(textfile);
      rename(textfile2,cfg^.lordpath + STARTBAT);

      msgbox('LordCops has been uninstalled');

    end;
  end;

end;

procedure writeConfigTail;
begin
  writeln(textfile,'-------------------------------------------------------------------');
  writeln(textfile,'Line 1 - Random Number multiplier for police actually doing anything');
  writeln(textfile,'         The lower, the more likely they come');
  writeln(textfile,'         1 means that it will run every time.');
  writeln(textfile);
  writeln(textfile,'Line 2 - Path to lord data files - must include trailing backslash');
  writeln(textfile);
  writeln(textfile,'Line 3 - Random Number multiplier for police raiding the Inn - this');
  writeln(textfile,'         _should_ be fairly high (meaning a lower chance of them');
  writeln(textfile,'         raiding), because the Inn should be a safe place.');
  writeln(textfile,'         The lower, the more likely to happen.');
  writeln(textfile,'         1 means that the police raid the inn EVERY TIME. (don''t do that!)');
  writeln(textfile,'         0 means that the police never raid the inn.');
  writeln(textfile);
  writeln(textfile,'Line 4 - Maximum number of HITPOINTS allowed.  0 to disable.');
  writeln(textfile);
  writeln(textfile,'Line 5 - Maximum amount of CASH allowed.  This is bank only funds.');
  writeln(textfile,'         0 to disable');
  writeln(textfile);
  writeln(textfile,'Line 6 - Maximum number of EXPERIENCE allowed.  0 to disable.');
  writeln(textfile);
  writeln(textfile,'Line 7 - Maximum number of DEFENSE allowed.  0 to disable.');
  writeln(textfile);
  writeln(textfile,'Line 8 - Maximum number of STRENGTH allowed.  0 to disable.');
  writeln(textfile);
  writeln(textfile,'Line 9 - Number of levels players are allowed to fight DOWN before the');
  writeln(textfile,'         police go after them. Set it to 13 to disable.');
  writeln(textfile);
  writeln(textfile,'Line 10 - Multiply this amount by their level CUBED, and you get the fine');
  writeln(textfile,'          for slaughtering lower-level players.');
  writeln(textfile,'          (i.e., level 3 with multiplier 40 would be 1080)');
  writeln(textfile);
  writeln(textfile,'Line 11 - Random Number chance of police raiding the Weapon or Armor shops.');
  writeln(textfile,'          2 would raid every 1 out of 2 times');
  writeln(textfile,'          0 to disable');
  writeln(textfile);
  writeln(textfile,'Line 12 - Multiply this amount by their level CUBED, and you get the amount');
  writeln(textfile,'          of cash ALL players get when the police raid either shop.');
  writeln(textfile,'          (i.e., Level 3 with multiplier 40 would be 1080).');
  writeln(textfile);
  writeln(textfile,'Line 13 - Random Number chance of Violet getting arrested for prostitution.');
  writeln(textfile,'          2 would have her get arrested 1 out of 2 times');
  writeln(textfile,'          0 to disable');
  writeln(textfile);
  writeln(textfile,'Line 14 - Random Number Addend after 1 for Violet''s "OUT" ness...');
  writeln(textfile,'          In other words, How long she''s out of the flirting scene...');
  writeln(textfile,'          6 could have her be out anywhere from 2 to 7 days.');
  writeln(textfile,'          0 makes it 1 day.');
  writeln(textfile,'Line 15 - The version of Lord to run for. "405" means anything from 3.55');
  writeln(textfile,'          to 4.05.. "407" means versions 4.06 or better');
end;

procedure resetConfigFile;
begin
  assign(textfile,copsdir + CONFIGFILE);
  rewrite(textfile);

  writeln(textfile,'5');
  writeln(textfile,'c:\bbs\lord');
  writeln(textfile,'20');
  writeln(textfile,'100');
  writeln(textfile,'800000000');
  writeln(textfile,'15000');
  writeln(textfile,'15');
  writeln(textfile,'15');
  writeln(textfile,'3');
  writeln(textfile,'40');
  writeln(textfile,'15');
  writeln(textfile,'30');
  writeln(textfile,'10');
  writeln(textfile,'1');
  writeln(textfile,'407');

  writeConfigTail;

  close(textfile);
end;

procedure saveConfigFile;
begin
  assign(textfile,copsdir + CONFIGFILE);
  rewrite(textfile);
  writeln(textfile,cfg^.dopolice);
  writeln(textfile,cfg^.lordpath);
  writeln(textfile,cfg^.policeinn);
  writeln(textfile,cfg^.maxhp);
  writeln(textfile,cfg^.maxcash);
  writeln(textfile,cfg^.maxxp);
  writeln(textfile,cfg^.maxdef);
  writeln(textfile,cfg^.maxstr);
  writeln(textfile,cfg^.levels);
  writeln(textfile,cfg^.fine);
  writeln(textfile,cfg^.raidshops);
  writeln(textfile,cfg^.raidreward);
  writeln(textfile,cfg^.violet);
  writeln(textfile,cfg^.vioout);
  writeln(textfile,cfg^.version);
  writeConfigTail;
  close(textfile);
end;

procedure readConfigFile;
var s:string;
begin
  assign(textfile,copsdir + CONFIGFILE);
  reset(textfile);

  {1}
  readln(textfile,s);
  cfg^.dopolice := StrToInt(s);

  {2}
  readln(textfile,s);
  cfg^.lordpath := s;
  if cfg^.lordpath <> '' then
    if cfg^.lordpath[length(cfg^.lordpath)] <> dirsep then
      cfg^.lordpath := cfg^.lordpath + dirsep;

  {3}
  readln(textfile,s);
  cfg^.policeinn := StrToInt(s);

  {4}
  readln(textfile,s);
  cfg^.maxhp := StrToInt(s);

  {5}
  readln(textfile,s);
  cfg^.maxcash := StrToInt(s);

  {6}
  readln(textfile,s);
  cfg^.maxxp := StrToInt(s);

  {7}
  readln(textfile,s);
  cfg^.maxdef := StrToInt(s);

  {8}
  readln(textfile,s);
  cfg^.maxstr := StrToInt(s);

  {9}
  readln(textfile,s);
  cfg^.levels := StrToInt(s);

  {10}
  readln(textfile,s);
  cfg^.fine := StrToInt(s);

  {11}
  readln(textfile,s);
  cfg^.raidshops := StrToInt(s);

  {12}
  readln(textfile,s);
  cfg^.raidreward := StrToInt(s);

  {13}
  readln(textfile,s);
  cfg^.violet := StrToInt(s);

  {14}
  readln(textfile,s);
  cfg^.vioout := StrToInt(s);

  {15}
  readln(textfile,s);
  if s[1]='-' then
    cfg^.version := 407
  else
    cfg^.version := StrToInt(s);
end;

procedure configuration;
var lite:^literec;
    choice:integer;
    varm5:m5;
    def:byte;
begin
  new(lite);

  readConfigFile;

  lite^.choices := 18;
  lite^.usehotkeys := true;

  for choice := 1 to 18 do
  begin
    lite^.menu[choice].skip := false;
  end;

   lite^.menu[1].letter := 'A';
   lite^.menu[2].letter := 'B';
   lite^.menu[4].letter := 'C';
   lite^.menu[5].letter := 'D';
   lite^.menu[6].letter := 'E';
   lite^.menu[7].letter := 'F';
   lite^.menu[8].letter := 'G';
   lite^.menu[9].letter := 'H';
  lite^.menu[10].letter := 'I';
  lite^.menu[11].letter := 'J';
  lite^.menu[12].letter := 'K';
  lite^.menu[13].letter := 'L';
  lite^.menu[14].letter := 'M';
  lite^.menu[15].letter := 'N';
  lite^.menu[16].letter := 'O';
  lite^.menu[18].letter := 'Q';

  lite^.menu[3].skip := true;
  lite^.menu[17].skip := true;

  lite^.menu[18].name := 'Quit and Save';

  on := 1;

  repeat
     lite^.menu[1].name := 'Chance of activity               : '+ IntToStr(cfg^.dopolice);
     lite^.menu[2].name := 'Path to Lord (line below)';
     lite^.menu[4].name := 'Chance of Inn Raid               : '+ IntToStr(cfg^.policeinn);
     lite^.menu[5].name := 'Maximum Hitpoints                : '+ IntToStr(cfg^.maxhp);
     lite^.menu[6].name := 'Maximum Gold                     : '+ IntToStr(cfg^.maxcash);
     lite^.menu[7].name := 'Maximum Experience               : '+ IntToStr(cfg^.maxxp);
     lite^.menu[8].name := 'Maximum Defense                  : ' + IntToStr(cfg^.maxdef);
     lite^.menu[9].name := 'Maximum Strength                 : ' + IntToStr(cfg^.maxstr);
    lite^.menu[10].name := 'Level Difference                 : ' + IntToStr(cfg^.levels);
    lite^.menu[11].name := 'Fine for Lower Level Kill        : ' + IntToStr(cfg^.fine);
    lite^.menu[12].name := 'Chance of Armor/Weapon Shop Raid : ' + IntToStr(cfg^.raidshops);
    lite^.menu[13].name := 'Gold when Raided                 : ' + IntToStr(cfg^.raidreward);
    lite^.menu[14].name := 'Chance of Violet/Prostitution    : ' + IntToStr(cfg^.violet);
    lite^.menu[15].name := 'Violet Out Time                  : ' + IntToStr(cfg^.vioout);
    lite^.menu[16].name := 'Version to run for               : ' + IntToStr(cfg^.version);


    clrscr;

    gotoxy(3,4);
    textcolor(15);
    write(cfg^.lordpath);

    gotoxy(3,2);
    choice := litebar(lite^);

    case choice of
    1: cfg^.dopolice := numbox(1,60000,cfg^.dopolice,'Chance of Activity');
    2: begin
         gotoxy(3,4);
         cfg^.lordpath := edi(3,4,60,1,15,cfg^.lordpath);
         gotoxy(3,4);
         clreol;
         if (cfg^.lordpath<>'') and (cfg^.lordpath[length(cfg^.lordpath)] <> dirsep) then
           cfg^.lordpath := cfg^.lordpath + dirsep;
       end;
    4: cfg^.policeinn := numbox(0,1000000,cfg^.policeinn,'Random Number multiplier for police raiding the Inn (1=everytime)');
    5: cfg^.maxhp := numbox(0,2000000000,cfg^.maxhp,'Maximum Hitpoints (0 disables)');
    6: cfg^.maxcash := numbox(0,2000000000,cfg^.maxcash,'Maximum Bank Account (0 disables)');
    7: cfg^.maxxp := numbox(0,2000000000,cfg^.maxxp,'Maximum Experience Points (0 disables)');
    8: cfg^.maxdef := numbox(0,2000000000,cfg^.maxdef,'Maximum Defense Points (0 disables)');
    9: cfg^.maxstr := numbox(0,2000000000,cfg^.maxstr,'Maximum Strength Points (0 disables)');
   10: cfg^.levels := numbox(1,13,cfg^.levels,'Number of level players are allowed to fight DOWN (13 disables)');
   11: cfg^.fine := numbox(0,100000,cfg^.fine,'Fine for attaching LL Players = this num * (level * level * level)');
   12: cfg^.raidshops := numbox(0,60000,cfg^.raidshops,'Random number multiplyer for raiding shops (0 to disable)');
   13: cfg^.raidreward := numbox(0,100000,cfg^.raidreward,'Reward for shop raid = this num * (level * level * level)');
   14: cfg^.violet := numbox(0,60000,cfg^.violet,'Chance of Violet getting arrested for prostitution (0 to disable)');
   15: cfg^.vioout := numbox(1,100,cfg^.vioout,'Days Violet is "out" once arrested (0=1 day)');
   16: begin
         varm5[1] := 'Versions 3.55 through 4.05';
         varm5[2] := 'Versions 4.06 or better';
         varm5[3] := '';
         varm5[4] := '';
         varm5[5] := '';
         if cfg^.version= 406 then def := 1 else def := 2;
         case picklite(def,'What version of Lord to run for?', varm5) of
         1: cfg^.version := 406;
         2: cfg^.version := 407;
         end;
       end;
   end; {case}

  until choice = lite^.choices;

  saveConfigFile;

  dispose(lite);
end;



var choice:integer;
    mainlite:^literec;

begin

  { set the directory we are running from, and assume that its
    where lordcops was installed to }
  copsdir := paramstr(0);
  while (length(copsdir)>0) and (copsdir[length(Copsdir)] <> dirsep) do
    delete(copsdir,length(copsdir),1);

  if not file_exists(copsdir + CONFIGFILE) then
    resetConfigFile;

  new(cfg);
  new(boxscreen);

  readConfigFile;

  new(mainlite);

  mainlite^.choices := 5;
  mainlite^.usehotkeys := true;

  mainlite^.menu[1].skip := false;
  mainlite^.menu[1].letter := 'A';
  mainlite^.menu[1].name := 'Configuration';

  mainlite^.menu[2].skip := false;
  mainlite^.menu[2].letter := 'B';
  mainlite^.menu[2].name := 'Install';

  mainlite^.menu[3].skip := false;
  mainlite^.menu[3].letter := 'C';
  mainlite^.menu[3].name := 'Uninstall';

  mainlite^.menu[4].skip := true;

  mainlite^.menu[5].skip := false;
  mainlite^.menu[5].letter := 'Q';
  mainlite^.menu[5].name := 'Quit';


  repeat
    clrscr;

    on := 1;

    gotoxy(4,4);
    choice := litebar(mainlite^);

    case choice of
    1: configuration;
    2: install;
    3: uninstall;
    end;

  until choice = mainlite^.choices;

  dispose(cfg);
  dispose(mainlite);
  dispose(boxscreen);
end.