program lordcops;

{$I whichos.inc}

uses dos,crt;


{ do this for easy cross platform support }
{$ifdef FORNIX}
const dirsep : char = '/';
{$else}
const dirsep : char = '\';
{$endif}

{ do this for easy cross platform support }
const
     COPTIMEDAT = 'COPTIME.DAT';
     LORDCOPSCFG = 'LORDCOPS.CFG';
     LOGOLDTXT = 'LOGOLD.TXT';
     LOGNOWTXT = 'LOGNOW.TXT';
     PLAYERDAT = 'PLAYER.DAT';
     MARRYDAT = 'MARRY.DAT';
     MARRAGEDAT = 'MARRAGE.DAT';

type TLordCop = record
       ran           : byte;
       path          : string; { path to lord }
       innatak       : byte;
       hitlimit      : integer;
       cashlimit     : longint;
       explimit      : longint;
       deflimit      : integer;
       strengthlimit : integer;
       levellimit    : byte;
       price         : longint;
       shopran       : byte;
       shopcash      : longint;
       violetmult    : byte;
       daysout       : byte;
       version       : integer;
     end;

{$I plinf405.pas}
{$I plinf407.pas}

var exitsave  : pointer; { save our exitproc}
    coppath   : string;  { path to lordcops.exe }
    copcfg    : ^TLordCop; { our config data }
    textfile  : text; { generic text file }
    logfile   : string; { which logfile will we be working with}
    innattack : boolean;
    increased : boolean;
    copnum    : byte;
    pl405     : ^player_info405;
    plfile405 : file of player_info405;
    playrec405: array[1..150] of ^player_info405;
    pl407     : ^player_info407;
    plfile407 : file of player_info407;
    playrec407: array[1..150] of ^player_info407;
    numplayers: byte;

function file_exists(s:string):boolean;
var DirInfo: SearchRec;
begin
  FindFirst(s,Archive,DirInfo);
  if DosError = 0 then
    file_exists := true
  else
    file_exists := false;
end;

function upstring(s:String):string;
var b:byte;
begin
  for b := 1 to length(s) do s[b] := upcase(s[b]);
  upstring := s;
end;

function lmon(n:longint):string;
var w,l:byte;
    s,f:string;
begin
  str(n,s);
  f := '';
  l := 0;
  for w := length(s) downto 1 do
  begin
    inc(l);
    f := s[w] + f;
    if (l > 2) and (l mod 3 = 0) and (l <> length(s)) then f := ',' + f ;
  end;
  lmon := f;
end;

procedure checktime;
var year, month, day, dow: word;
    datetest,datetest2: string;
begin
  IF NOT File_Exists(coppath+COPTIMEDAT) then
  begin
    assign(textfile,coppath+COPTIMEDAT);
    rewrite(textfile);
    GetDate(year,month,day,dow);
    str(year+month+day,datetest);
    writeln(textfile, datetest);
    close(textfile);
    Exit;
  end;

  assign(textfile,coppath+COPTIMEDAT);
  reset(textfile);
  readln(textfile,datetest);
  close(textfile);
  getdate(year,month,day,dow);
  str(year+month+day,datetest2);
  IF (datetest = datetest2) then
  begin
    clrscr;
    writeln('You''ve already run maintenance today!');
    writeln('To run it again (today) delete "COPTIME.DAT"');
    halt;
  end;
  assign(textfile,coppath+COPTIMEDAT);
  rewrite(textfile);
  GetDate(year,month,day,dow);
  writeln(textfile, year+month+day);
  close(textfile);
end;

procedure readcfg;
begin
  if not file_exists(coppath+LORDCOPSCFG) then
  begin
    writeln('The file '+coppath+LORDCOPSCFG+' doesn''t exist.');
    writeln('LordCops has not been installed! Halting!');
    halt;
  end;
  assign(textfile, coppath+LORDCOPSCFG);
  reset(textfile);
  readln(textfile, copcfg^.ran);
  readln(textfile, copcfg^.path); { path to lord }
  readln(textfile, copcfg^.innatak);
  readln(textfile, copcfg^.hitlimit);
  readln(textfile, copcfg^.cashlimit);
  readln(textfile, copcfg^.explimit);
  readln(textfile, copcfg^.deflimit);
  readln(textfile, copcfg^.strengthlimit);
  readln(textfile, copcfg^.levellimit);
  readln(textfile, copcfg^.price);
  readln(textfile, copcfg^.shopran);
  readln(textfile, copcfg^.shopcash);
  readln(textfile, copcfg^.violetmult);
  readln(textfile, copcfg^.daysout);

  { this next bit is wrapped in $I+ and $I- for backwards compatibility }
  {$I-}readln(textfile, copcfg^.version);{$I+} {either 405 or 407 }
  if ioresult <> 0 then copcfg^.version := 405; {specifies what player.dat
                                                to use}
  close(textfile);
end;


procedure readin_405;
var prostitute : boolean;
begin
  prostitute := false;
  assign(plfile405,copcfg^.path+PLAYERDAT);
  reset(plfile405);
  numplayers := 0;
  repeat
    inc(numplayers);
    read(plfile405,playrec405[numplayers]^);
    IF (playrec405[numplayers]^.on_now) then
    begin
      writeln('A player''s on-line!!!');
      close(plfile405);
      halt;
    end;

    IF (playrec405[numplayers]^.names = 'Rehabilitation') then
    begin
      playrec405[numplayers]^.names := 'X';
      prostitute := true;
      copnum := numplayers;
    end;

    IF (playrec405[numplayers]^.names = 'Rehab') then
    begin
      prostitute := true;
      copnum := numplayers;
    end;
  until eof(plfile405);

  IF (NOT prostitute) and (numplayers < 150) then
  begin
    inc(numplayers);
    copnum := numplayers;

    playrec405[numplayers]^.names := 'X';
    playrec405[numplayers]^.real_names := 'Rehab';

    IF copcfg^.explimit > 0 then
      playrec405[numplayers]^.exp := copcfg^.explimit
    else
      playrec405[numplayers]^.exp := 800000000;

    IF copcfg^.strengthlimit > 0 then
      playrec405[numplayers]^.strength := copcfg^.strengthlimit
    else
      playrec405[numplayers]^.strength := 2000;

    if copcfg^.deflimit > 0 then
      playrec405[numplayers]^.def := copcfg^.deflimit
    else
      playrec405[numplayers]^.def := 2000;

    playrec405[numplayers]^.weapon := 'Billy Club';
    playrec405[numplayers]^.arm := 'Bullet Proof Vest';
    playrec405[numplayers]^.lays := 0;
    playrec405[numplayers]^.level := 12;
    increased := true;
  end;

  close(plfile405);
end;

procedure readin_407;
var prostitute : boolean;
    i:byte;
begin
  prostitute := false;
  assign(plfile407,copcfg^.path+PLAYERDAT);
  reset(plfile407);
  numplayers := filesize(plfile407);
  i := 0;
  repeat
    inc(i);
    read(plfile407,playrec407[i]^);
    IF (playrec407[i]^.on_now) then
    begin
      writeln('A player''s on-line!!!');
      close(plfile407);
      halt;
    end;

    IF (playrec407[i]^.names = 'Rehabilitation') then
    begin
      playrec407[i]^.names := 'X';
      prostitute := true;
      copnum := i;
    end;

    IF (playrec407[i]^.names = 'Rehab') then
    begin
      prostitute := true;
      copnum := i;
    end;
  until eof(plfile407);

  IF (NOT prostitute) and (numplayers<150) then
  begin
    inc(numplayers);
    i := numplayers;
    copnum := numplayers;

    playrec407[i]^.names := 'X';
    playrec407[i]^.real_names := 'Rehab';

    IF copcfg^.explimit > 0 then
      playrec407[i]^.exp := copcfg^.explimit
    else
      playrec407[i]^.exp := 800000000;

    IF copcfg^.strengthlimit > 0 then
      playrec407[i]^.strength := copcfg^.strengthlimit
    else
      playrec407[i]^.strength := 2000;

    if copcfg^.deflimit > 0 then
      playrec405[numplayers]^.def := copcfg^.deflimit
    else
      playrec407[i]^.def := 2000;

    playrec407[i]^.weapon := 'Billy Club';
    playrec407[i]^.arm := 'Bullet Proof Vest';
    playrec407[i]^.who_cares := 0;
    playrec407[i]^.level := 12;
    increased := true;
  end;

  close(plfile407);
end;

procedure screenwrite;
  begin
    textcolor(7);
    textbackground(0);
    clrscr;
    writeln('LORDCops v2.00 :: By Michael Preslar');
    writeln;
    writeln('Visit http://www.michaelpreslar.com for all sorts of goodies!');
    writeln;
    writeln('Working on: ');
  end;


procedure checkmarriage;
var tempstr2:string;
    deadly:byte;
begin
  IF NOT file_exists(coppath+MARRYDAT) then
  begin
    assign(textfile, coppath+MARRYDAT);
    rewrite(textfile);
    writeln(textfile, '0');
    close(textfile);
  end;

  assign(textfile, coppath+MARRYDAT);
  reset(textfile);
  readln(textfile, deadly);
  close(textfile);

  IF deadly = 0 then exit;

  IF deadly = 1 then
  begin
    deadly := 0;
    assign(textfile, copcfg^.path+MARRAGEDAT);
    rewrite(textfile);
    writeln(textfile, '-1');
    close(textfile);

    assign(textfile,copcfg^.path+LOGNOWTXT);
    append(textfile);
    writeln(textfile,'`#  Violet `2was released from jail today!');
    writeln(textfile, '`.                                `2-`0=`2-`0=`2-`0=`2-');
    close(textfile);
    exit;
  end;

  dec(deadly);

  iF (deadly = 1) then
     tempstr2 := 'day'
  else
     tempstr2 := 'days';

  assign(textfile, copcfg^.path+LOGNOWTXT);
  append(textfile);
  writeln(textfile,'`#  Violet `2still has `4',deadly,'`2 ',tempstr2,' of confinement left.');
  writeln(textfile,'                                `2-`0=`2-`0=`2-`0=`2-');
  close(textfile);

  assign(textfile,coppath+MARRYDAT);
  rewrite(textfile);
  writeln(textfile,deadly);
  close(textfile);
end;

procedure prostitution;
var deadly,temp:integer;
begin
  IF copcfg^.violetmult = 0 then exit;

  if random(copcfg^.violetmult)+1 = 1 then
  begin
    if file_exists(copcfg^.path+MARRAGEDAT) then
    begin
      assign(textfile,copcfg^.path+MARRAGEDAT);
      reset(textfile);
      readln(textfile, temp);
      close(textfile);
      if NOT (temp = 255) then exit;
    end;

    assign(textfile,copcfg^.path+LOGNOWTXT);
    append(textfile);
    writeln(textfile,'`#  Violet `2was arrested for prostitution last night!');
    writeln(textfile,'                                `2-`0=`2-`0=`2-`0=`2-');
    close(textfile);

    assign(textfile, copcfg^.path+MARRAGEDAT);
    rewrite(textfile);
    writeln(textfile,copnum-1);
    close(textfile);

    IF copcfg^.DAYSOUT <> 0 then
      deadly := 1 + RANDOM(copcfg^.daysout)
    else
      deadly := 0;

    assign(textfile, coppath+MARRYDAT);
    rewrite(textfile);
    writeln(textfile, deadly);
    close(textfile);
  end;
end;

procedure InnAssault;
var anger: byte;
begin
  IF copcfg^.innatak = 0 then exit;

  anger := 1+random(copcfg^.innatak);

  if anger = 1 then
  begin
    innattack := true;
    assign(textfile,copcfg^.path+LOGNOWTXT);
    append(textfile);
    writeln(textfile,'`2  The `0Lord Police `2raided the Inn last night.');
    writeln(textfile,'                                `2-`0=`2-`0=`2-`0=`2-');
    close(textfile);
  end;
end;

procedure SHOPPING;
var shopname: string[20];
    tempstr:string;
    w : byte;
    long:longint;
begin
  IF copcfg^.SHOPRAN = 0 then exit;

  if random(2) = 0 then
    shopname := 'Armor'
  else
    shopname := 'Weapon';

  if random(copcfg^.shopran) = 1 then
  begin
    assign(textfile,copcfg^.path+LOGNOWTXT);
    append(textfile);
    writeln(textfile,'`2  The `0Lord Police `2raided the ',shopname,' Shop last night.');
    writeln(textfile,'                                `2-`0=`2-`0=`2-`0=`2-');
    close(textfile);
    for w := 1 to numplayers do
    begin
      str(w-1,tempstr);
      IF NOT file_exists(copcfg^.path+'MAIL'+tempstr+'.DAT') then
      begin
        assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
        rewrite(textfile);
        close(textfile);
      end;
      assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
      append(textfile);
      IF NOT innattack then
      begin
        writeln(textfile,'`%  -*- The Police Bulletin -*-');
        writeln(textfile,'`2-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-');
      end;
      writeln(textfile,'`0  The Lord Police `2raided the ',shopname,' Shop last night!');
      writeln(textfile,'');

      if copcfg^.version = 405 then
      begin
        long := copcfg^.shopcash*(playrec405[w]^.level*playrec405[w]^.level*playrec405[w]^.level);
        if MaxLongInt - playrec405[w]^.bank >= long then
          inc(playrec405[w]^.bank,long)
        else
        begin
          long := MaxLongInt - playrec405[w]^.bank;
          playrec405[w]^.bank := MaxLongInt;
        end;
      end
      else
      begin
        long := copcfg^.shopcash*(playrec407[w]^.level*playrec407[w]^.level*playrec407[w]^.level);
        if MaxLongInt - playrec407[w]^.bank >= long then
          inc(playrec407[w]^.bank,long)
        else
        begin
          long := MaxLongInt - playrec407[w]^.bank;
          playrec407[w]^.bank := MaxLongInt;
        end;
      end;

      writeln(textfile,'`2  You receive `%',lmon(long),' `2in compensation.');
      writeln(textfile,'');
      close(textfile);
    end;
  end;
end;

procedure maximums(w:byte);
var temp:string;
    tempstr:string;
    level:byte;
    hit_max:longint;
    bank:longint;
    exp:longint;
    long:longint;
    def:longint;
    strength:longint;
begin
  str(w-1,tempstr);
  if copcfg^.version = 405 then
  begin
    level := playrec405[w]^.level;
    hit_max := playrec405[w]^.hit_max;
    bank := playrec405[w]^.bank;
    exp := playrec405[w]^.exp;
    def := playrec405[w]^.def;
    strength := playrec405[w]^.strength;
  end
  else
  begin
    level := playrec407[w]^.level;
    hit_max := playrec407[w]^.hit_max;
    bank := playrec407[w]^.bank;
    exp := playrec407[w]^.exp;
    def := playrec407[w]^.def;
    strength := playrec407[w]^.strength;
  end;

  IF (hit_max > copcfg^.hitlimit) and NOT (copcfg^.hitlimit = 0) then
  begin
    long := (level*level*level)*(50)*(hit_max-copcfg^.hitlimit);
    assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
    {$I-}append(textfile);{$I+}
    if ioresult<>0 then rewrite(textfile);
    writeln(textfile,'`2');
    writeln(textfile,'`2  The Lord Police find you in violation with the HitLimit Clause.');
writeln(textfile,'`2  Since you are `$',lmon(hit_max - copcfg^.hitlimit),' ` 2over the limit of `%',lmon(copcfg^.hitlimit));
    writeln(textfile,'`2  your fine is `%',lmon(long),' `2gold.');
    close(textfile);
    if copcfg^.version = 405 then
    begin
      dec(playrec405[w]^.bank,long);
      if playrec405[w]^.bank < 1 then playrec405[w]^.bank := 0;
    end
    else
    begin
      dec(playrec407[w]^.bank,long);
      if playrec407[w]^.bank < 1 then playrec407[w]^.bank := 0;
    end;
  end;

  IF (bank > copcfg^.cashlimit) and NOT (copcfg^.cashlimit = 0) then
  begin
    long := (10)*(hit_max-copcfg^.cashlimit);
    assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
    {$I-}append(textfile);{$I+}
    if ioresult<>0 then rewrite(textfile);
    writeln(textfile,'`2');
    writeln(textfile,'`2  The Lord Police find you in violation with the CashLimit Clause.');
    writeln(textfile,'`2  Since you are `4',lmon(bank - copcfg^.cashlimit),' ` 2over the limit of `4',lmon(copcfg^.cashlimit));
    writeln(textfile,'`2  your fine is `$',lmon(long),' `2gold.');
    close(textfile);
    if copcfg^.version = 405 then
    begin
      dec(playrec405[w]^.bank,long);
      if playrec405[w]^.bank < 1 then playrec405[w]^.bank := 0;
    end
    else
    begin
      dec(playrec407[w]^.bank,long);
      if playrec407[w]^.bank < 1 then playrec407[w]^.bank := 0;
    end;
  end;

  IF (exp > copcfg^.explimit) and NOT (copcfg^.explimit = 0) then
  begin
    long := (10)*(exp-copcfg^.explimit);
    assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
    {$I-}append(textfile);{$I+}
    if ioresult<>0 then rewrite(textfile);
    writeln(textfile,'`2');
    writeln(textfile,'`2  The Lord Police find you in violation with the Experience Clause.');
    writeln(textfile,'`2  Since you are `4',lmon(exp - copcfg^.explimit),' ` 2over the limit of `4',lmon(copcfg^.explimit));
    writeln(textfile,'  `2your fine is `4',lmon(long),' `2gold.');
    close(textfile);
    if copcfg^.version = 405 then
    begin
      dec(playrec405[w]^.bank,long);
      if playrec405[w]^.bank < 1 then playrec405[w]^.bank := 0;
    end
    else
    begin
      dec(playrec407[w]^.bank,long);
      if playrec407[w]^.bank < 1 then playrec407[w]^.bank := 0;
    end;
  end;

  IF (def > copcfg^.deflimit) and NOT (copcfg^.deflimit = 0) then
  begin
    long := (level*level*level)*(50)*(def-copcfg^.deflimit);
    assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
    {$I-}append(textfile);{$I+}
    if ioresult<>0 then rewrite(textfile);
    writeln(textfile,'`2');
    writeln(textfile,'`2  The Lord Police find you in violation with the Defense Clause.');
    writeln(textfile,'`2  Since you are `4',lmon(def - copcfg^.deflimit),' ` 2over the limit of `4',lmon(copcfg^.deflimit));
    writeln(textfile,'`2  your fine is `4',lmon(long),' `2gold.');
    close(textfile);
    if copcfg^.version = 405 then
    begin
      dec(playrec405[w]^.bank,long);
      if playrec405[w]^.bank < 1 then playrec405[w]^.bank := 0;
    end
    else
    begin
      dec(playrec407[w]^.bank,long);
      if playrec407[w]^.bank < 1 then playrec407[w]^.bank := 0;
    end;
  end;

  IF (strength > copcfg^.strengthlimit) and NOT (copcfg^.strengthlimit = 0) then
  begin
    long := (level*level*level)*(50)*(strength-copcfg^.strengthlimit);
    assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
    {$I-}append(textfile);{$I+}
    if ioresult <> 0 then rewrite(textfile);
    writeln(textfile,'`2');
    writeln(textfile,'`2  The Lord Police find you in violation with the Strength Clause.');
    writeln(textfile,'`2  Since you are `4',lmon(strength - copcfg^.strengthlimit),
        ' `2over the limit of `4',lmon(copcfg^.strengthlimit));
    writeln(textfile,'`2  your fine is `4',lmon(long),' `2gold.');
    close(textfile);
    if copcfg^.version = 405 then
    begin
      dec(playrec405[w]^.bank,long);
      if playrec405[w]^.bank < 1 then playrec405[w]^.bank := 0;
    end
    else
    begin
      dec(playrec407[w]^.bank,long);
      if playrec407[w]^.bank < 1 then playrec407[w]^.bank := 0;
    end;
  end;
end;

procedure lowerlevels(w:byte);
var exist:boolean;
    tempstr,
    tempst: string;
    r,z:byte;
    temp:array[1..149] of string[32];
    names : string;
    long:longint;
    level:byte;
begin
    if copcfg^.version = 405 then
    begin
      names := playrec405[w]^.names;
      level := playrec405[w]^.level;
      assign(plfile405,copcfg^.path+PLAYERDAT);
      reset(plfile405);
      r := 1;
      repeat
        read(plfile405,pl405^);
        IF (pl405^.level < (playrec405[w]^.level - copcfg^.levellimit)) then
        begin
          temp[r] := pl405^.names;
          inc(r);
        end;
      until eof(plfile405);
      close(plfile405);
    end
    else
    begin
      level := playrec407[w]^.level;
      names := playrec407[w]^.names;
      assign(plfile407,copcfg^.path+PLAYERDAT);
      reset(plfile407);
      r := 1;
      repeat
        read(plfile407,pl407^);
        IF (pl407^.level < (playrec407[w]^.level - copcfg^.levellimit)) then
        begin
          temp[r] := pl407^.names;
          inc(r);
        end;
      until eof(plfile407);
      close(plfile407);
    end;

    IF NOT file_exists(copcfg^.path+logfile) then exit;

    assign(textfile,copcfg^.path+logfile);
    reset(textfile);
    exist := false;
    repeat
      readln(textfile, tempst);
      IF (POS(names,tempst) > 0) and (POS('self d', tempst) = 0) then
        for z := 1 to r do
          If (pos(temp[z], tempst) > 0) then
            exist := true;
    until eof(textfile) or exist;

    close(textfile);

    IF exist then
    begin
      long := (copcfg^.price)*(level*level*level);
      str(w-1,tempstr);
      assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
      {$I-}append(textfile);{$I+}
      if ioresult<>0 then rewrite(textfile);
      writeln(textfile,'`2');
      writeln(textfile,'`2  The Lord Police find you GUILTY of Assault & Battery on a minor.');
      writeln(textfile,'`2  Your fine is `4',lmon(long));
      close(textfile);
      if copcfg^.version = 405 then
      begin
        dec(playrec405[w]^.bank,long);
        if playrec405[w]^.bank < 1 then playrec405[w]^.bank := 0;
      end
      else
      begin
        dec(playrec407[w]^.bank,long);
        if playrec407[w]^.bank < 1 then playrec407[w]^.bank := 0;
      end;
    end;
end;


procedure readback;
var w:byte;
begin
  if copcfg^.version = 405 then
  begin
    assign(plfile405,copcfg^.path+PLAYERDAT);
    rewrite(plfile405);
    for w := 1 to numplayers do write(plfile405,playrec405[w]^);
    close(plfile405);
  end
  else
  begin
    assign(plfile407,copcfg^.path+PLAYERDAT);
    rewrite(plfile407);
    for w := 1 to numplayers do write(plfile407,playrec407[w]^);
    close(plfile407);
  end;
  halt;
end;



var tempbyte1,         { dummy variables }
    tempbyte2 : byte;
    tempstr:string;

{$F+}
procedure myexit;

begin
  { always set this back first }
  exitproc := exitsave;

  dispose(copcfg);

  for tempbyte1 := 1 to 150 do
  begin
    dispose(playrec405[tempbyte1]);
    dispose(playrec407[tempbyte1]);
  end;

  dispose(pl405);
  dispose(pl407);

end;
{$F-}

(**************************************************************************
                          MAIN CODE BLOCK
***************************************************************************)
begin
  { get the directory where lordcops is running from}
  coppath := paramstr(0);
  while coppath[length(coppath)] <> dirsep do
    delete(coppath,length(coppath),1);

  { check to see if weve already run today}
  checktime;

  { set some default values }
  increased := false;
  innattack := false;

  for tempbyte1 := 1 to 150 do
  begin
    new(playrec405[tempbyte1]);
    new(playrec407[tempbyte1]);
  end;

  new(copcfg);

  new(pl405);
  new(pl407);

  { set this up}
  exitsave := exitproc;
  exitproc := @myexit;


  { read in the config file}
  readcfg;

  { make sure there's a player.dat }
  if not file_exists(copcfg^.path+PLAYERDAT) then
  begin
    writeln('The file '+copcfg^.path+PLAYERDAT+' doesn''t exist!');
    writeln('Halting!');
    halt;
  end;

  { announce that were running }
  screenwrite;

  { lets see if were running today }
  for tempbyte1 := 1 to 10 do
    tempbyte2 := 1 + random(copcfg^.ran);

  if tempbyte2<>1 then
  begin
    writeln('  - The Lord Cops did not visit today');
    halt;
  end
  else
  begin
    writeln('  - The Lord Cops visited the town today!');
  end;

  { else they did visit }

  assign(textfile,copcfg^.path+LOGNOWTXT);
  {$I-}append(textfile);{$I+}
  if ioresult <> 0 then rewrite(textfile);
  writeln(textfile,'`0  The Police `2visited the town today.');
  writeln(textfile,'                                `2-`0=`2-`0=`2-`0=`2-');
  close(textfile);

  writeln('  - ''New'' ing our pointers');

  writeln('  - Reading in the players');

  { read in the players }
  if copcfg^.version = 405 then
    readin_405
  else
    readin_407;

  { set which logfile were working with }
  if paramcount = 0 then
    logfile := LOGOLDTXT
  else
  if upstring(paramstr(1)) = 'MAINT' then
    logfile := LOGNOWTXT;

  { How long until Violet is divorced? }
  writeln('  - Checking Violet''s marriage');
  checkmarriage;

  { will violet get arrested for prostitution? }
  writeln('  - Checking Violet for prostitution');
  prostitution;

  { raid the Inn or not? }
  writeln('  - Will the police raid the Inn?');
  InnAssault;

  { raid either the weapon or armor shop }
  writeln('  - Will the shops get raided?');
  shopping;

  { why Joe didnt put this next bit in a procedure, I dont know.
    But, since its okay where it is, Im not changing it }

  IF increased then
    tempbyte1 := numplayers-1
  else
    tempbyte1 := numplayers;

  for tempbyte2 := 1 to tempbyte1 do
  begin
    str(tempbyte2-1,tempstr);
    if copcfg^.version = 405 then
    begin
      writeln(playrec405[tempbyte2]^.names,' ':(65-LENGTH(playrec405[tempbyte2]^.names)));

      if (playrec405[tempbyte2]^.dead <> 5) then
      begin

      IF (innattack = false) and (playrec405[tempbyte2]^.inn = 5) then
      begin
        IF NOT FILE_EXISTS(copcfg^.path+'MAIL'+tempstr+'.DAT') then
        begin
          assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
          rewrite(textfile);
          close(textfile);
        end;
        assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
        append(textfile);
        writeln(textfile,'`%  -*- The Police Bulletin -*-');
        writeln(textfile,'`2-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-');
        writeln(textfile,'`0  The Police `2stopped by the inn last night, looking for you.');
        writeln(textfile,'`2');
        writeln(textfile,'`2  Luckily, the bartender and Seth Able held them off.');
        writeln(textfile,'');
        close(textfile);
      end
      else
      begin
        maximums(tempbyte2);
        lowerlevels(tempbyte2);
      end;
      end;
    end
    else
    begin
      writeln(playrec407[tempbyte2]^.names,' ':(65-LENGTH(playrec407[tempbyte2]^.names)));

      if (playrec407[tempbyte2]^.dead <> 5) then
      begin

      IF (innattack = false) and (playrec407[tempbyte2]^.inn = 5) then
      begin
        IF NOT FILE_EXISTS(copcfg^.path+'MAIL'+tempstr+'.DAT') then
        begin
          assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
          rewrite(textfile);
          close(textfile);
        end;
        assign(textfile,copcfg^.path+'MAIL'+tempstr+'.DAT');
        append(textfile);
        writeln(textfile,'`%  -*- The Police Bulletin -*-');
        writeln(textfile,'`2-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-');
        writeln(textfile,'`0  The Police `2stopped by the inn last night, looking for you.');
        writeln(textfile,'`2');
        writeln(textfile,'`2  Luckily, the bartender and Seth Able held them off.');
        writeln(textfile,'');
        close(textfile);
      end
      else
      begin
        maximums(tempbyte2);
        lowerlevels(tempbyte2);
      end;
      end;
    end;
  end;
  writeln('  - Done!');
  readback;

end.